# -*- coding: utf-8 -*-
import random 
import math
import numpy as np

class Agent(object):
    def __init__(self,x,y,d,vMax=5.5,F=0,A=0.3,B=0.3):  #Alle Informationen des Menschen werden gespeichert
        self.pos = np.array([x,y])
        self.Vis = None
        self.aim1 = np.array([0,0])
        self.aim2 = np.array([0,-5])
        self.d = d  #d Durchmesser
        self.vAct = np.array([0,0])
        self.vMax = vMax
        self.vDes = 0.24 * self.vMax
        self.F = np.array([F,F])   #F Kraft
        self.lamb = 0
        self.A = A
        self.B = B
        self.panicLevel = 1

    def getX(self):
        return self.pos[0]
    def getY(self):
        return self.pos[1]
    x = property(getX)
    y = property(getY)
        

class Direction(object):    #Spielt keine Rolle mehr
    '''Konstruktion eines Fluchtvektorfelds durch die untere Tuer von Hand.
    Fuer allgemeinere Situationen wird es besser sein, ein solches Vektorfeld
    ueber die Berechnung des (ohne andere Menschen) kuerzesten Wegs
    zu bestimmen.'''
    
    door = 1.5
    bt = door/5 # bt = Breite Transitionzone
    tiefe = 1.5*door
    def h1(self,x,y,agent=None):
        if x < (agent.aim1[0]-self.door/2) or x > agent.aim1[0]+self.door/2 or y > agent.aim1[1]+self.tiefe:
            return 1
        elif x > agent.aim1[0]-self.door/2 + self.bt and x < agent.aim1[0] + self.door/2 - self.bt and y < agent.aim1[1]+self.tiefe - self.bt:
            return 0
        else:
            a1 = -(x-(agent.aim1[0]-self.door/2+self.bt))*(1/self.bt)
            a2 = (y-(agent.aim1[1]+self.tiefe-self.bt))*(1/self.bt)
            a3 = (x-(agent.aim1[0]+self.door/2-self.bt))*(1/self.bt)
            return max(a1,a2,a3)
    def h2(self,x,y,agent):
        return 1-self.h1(x,y, agent=agent)
    def get_direction(self,agent):
        if agent.pos[1]<agent.aim1[1]:
            return agent.aim2 -agent.pos
        else:
            return -self.h1(*agent.pos,agent=agent) * (agent.pos - agent.aim1) - self.h2(*agent.pos,agent=agent) *(agent.pos-agent.aim2)



# A=Anziehungsbestreben und B=Abstoßungsbestreben sind feste Werte

#NAME
