# -*- coding: utf-8 -*-
import turtle as t
import math
import numpy as np
from Boundery import Boundery
from copy import deepcopy
import pickle


class Model(object):    #Hier werden neue Modelle erzeugt
    def __init__(self,wallWidth=0.15):  #Alle notwendingen Variablen werden deklariert
        print "Ziehe zunaechst den angegebenen Massstab nach."
        print "Dannach musst du in der linken unteren Ecke starten"
        self.n = 0
        self.bounderies = []
        self.bounderiesAsBoundery = []
        self.aims = []
        self.aimsAsBounderies = []
        self.massstab = int(raw_input("Massstab in Meter:  "))
        self.skale = 0.0
        self.wallWidth = wallWidth
        self.plan=str(raw_input("Plantitel: "))[:-1]    #Name des Plans wird abgefragt

    def createBounderies(self,x,y): #Hier werden die Wände über Turtle entgegen genommen
        #Die ersten beiden Eingaben für den Maßstab
        if self.n==0:
            self.screen.color("yellow")
            self.screen.pu()
            self.skale = x
        elif self.n==1:
            self.screen.pd()
            self.skale = self.massstab/abs(self.skale-x)
            #Jeder zweite Punkt wird mit Linie verbunden
            #Es muss für jede Wand anfangs und Endpunkt gegeben werden
        elif self.n%2==0:
            self.screen.pencolor("red")
            self.screen.pu()
            self.bounderies.append(np.array([self.skale*x,self.skale*y]))
        else:
            self.screen.pd()
            #Punkte werden gleich entsprechend angepasst, damit sie Rechtecke sind und gleich auf Meter skaliert
            if abs(self.skale*x - self.bounderies[-1][0])>abs(self.skale*y - self.bounderies[-1][1]):
                self.bounderies.append(np.array([self.skale*x,self.bounderies[self.n-3][1]+ self.wallWidth]))
            else:
                self.bounderies.append(np.array([self.bounderies[-1][0]+ self.wallWidth,self.skale*y]))
            if self.bounderies[-1][0]<self.bounderies[-2][0] and self.bounderies[-1][1]>self.bounderies[-2][1]:
                self.bounderies[-1][1],self.bounderies[-2][1] = self.bounderies[-2][1],self.bounderies[-1][1]
            
        self.n += 1
        self.screen.goto(x,y)
        
    def createAims(self,x,y):   #Hier werden die Ziele(Türen) über Turtle entgegen genommen
        dis = 3
        self.screen.pencolor("green")
        #Jeder zweite Punkt wird über Linie verbunden
        if len(self.aims)%2==0:
            self.screen.pu()
            self.aims.append(np.array([self.skale*x,self.skale*y]))
        else:
            self.screen.pd()
            #Skalierung und Anpassung zum Ziel
            #Dieser Teil ist falsch und funktioniert nur eingeschränkt(Türen können in diesem Programm nur an der unteren
            #oder rechten Wand sein)
            #Außerdem sind noch andere Fehler aufgetreten, muss auf jeden Fall noch verändert werden
            if abs(self.skale*x - self.aims[-1][0])>abs(self.skale*y - self.aims[-1][1]):
                self.aims.append(np.array([self.skale*x,self.aims[-1][1]+ self.wallWidth-dis]))
                self.aims[-2][1]-=dis
            else:
                self.aims.append(np.array([self.aims[-1][0]+ self.wallWidth-dis,self.skale*y]))
                self.aims[-2][0] -=dis
            if self.aims[-1][0]<self.aims[-2][0] and self.aims[-1][1]>self.aims[-2][1]:
                self.aims[-1][1],self.aims[-2][1] = self.aims[-2][1],self.aims[-1][1]
        self.screen.goto(x,y)
        
    def turtleexit(self,x,y):   #Beendet Turtle
        self.screen.bye()
    
    def main(self,model):   #Hauptprogramm
        self.screen=t.Screen()
        self.screen.setup(1000,400)
        self.screen.bgpic(self.plan)    #Bild als Hintergrund
        self.screen.pensize(5)
        self.screen.onscreenclick(self.createBounderies,btn=1)  #Linke Maustaste für Wände
        self.screen.onscreenclick(self.createAims,btn=3)        #Rechte Maustaste für Ziele(Türen)
        self.screen.onscreenclick(self.turtleexit,btn=2)        #Mausrad klicken zum beenden
        self.screen.mainloop()  #damit wartet Turtle auf Eingaben
        temp = deepcopy(self.bounderies[0])
        for j in (self.bounderies): #Punkt unten links wird (0,0), der Rest wird dementsprechend angepasst
            j -= temp 
        i = 0
        while i < len(self.bounderies): #Wandpunkte werden in den richtigen Datentyp gebracht
            self.bounderiesAsBoundery.append(Boundery(self.bounderies[i],self.bounderies[i+1]))
            i += 2
        i = 0
        while i < len(self.aims):   #Zielpunkte werden in den richtigen Datentyp gebracht
            self.aimsAsBounderies.append(Boundery(self.aims[i]-temp,self.aims[i+1]-temp))
            i += 2
        #Speicherung mithilfe von Pickle( __!!!__ Das gespeicherte lässt sich nur durch Python Programme auslesen)
        fil = open(str("Model"+str(model)),"wb")
        pickle.dump([self.bounderiesAsBoundery,self.aimsAsBounderies],fil)
        fil.close()
        
if __name__ == "__main__":  #nicht Relevant für die eigentliche Ausführung der Programms
    a = Model()
    a.main(1)
