# -*- coding: utf-8 -*-
from Agent import Agent, Direction
from Space import Space
from Boundery import Boundery
import numpy as np
import random as r
import time
import math
import laufweg

direction_object = Direction()

#Hauptprogramm zur Berechnung der neuen Positionen
class Mover():
    def __init__(self,agents,space,t=1):    #Übergabe aller Informationen
        self.t = t  #Zeitschritt
        self.agents = agents
        self.counter = 0
        self.space = space
        self.perturbation = 0.05
        n = int((self.space.width+self.space.height)/2 * 10)
        if n<200: n=200
        # Berechnung des Vektorfelds
        self.getdirection = laufweg.make_direction_function(self.space.bounderies,self.space.aims,0,space.width,0,space.height,n = n)

    def force(self,app):    #Dieser Teil wird als Thread ausgeführt
        time.sleep(2)
        while True: #dauerhaft aktiv durch True-Schleife
            time.sleep(0.1)
            z =[]
            i = r.randint(0,(len(self.agents)-1))   
            while len(z)<len(self.agents):  #Jeder Agent wird einmal bewegt
                while i in z:
                    i = r.randint(0,len(self.agents)-1) #Zufällige Reihenfolge der Bewegung der Menschen
                z.append(i)
                fAcc = self.accelerationForce(self.agents[i])   # Beschleunigungskraft des Menschen
                self.agents[i].vAct = fAcc
                fSoc = 0
                fBoun = 0
                for  j in range(len(self.agents)):
                    if (i!=j):
                        fSoc += self.socialForce(i,j)   #Soziale Kräfte(Wirkung anderer Menschen)
                if self.space.bounderies!=[]:
                    for boundery in self.space.bounderies:
                        fBoun += self.bounderyForce(self.agents[i],boundery)    #Abstoßung von Wänden
                self.agents[i].F = (fAcc + fSoc + fBoun)*self.t
                a = True
                while a:
                    testpos= np.array([self.agents[i].pos[0],self.agents[i].pos[1]]) + self.agents[i].F
                    for j in range (len(self.agents)):
                        if i!=j:
                            #dist_pos_j_pos = math.sqrt((self.agents[j].pos[0]-self.agents[i].pos[0])**2+(self.agents[j].pos[1]-self.agents[i].pos[1])**2)
                            dist_pos_j_test_pos = math.sqrt((self.agents[j].pos[0]-testpos[0])**2+(self.agents[j].pos[1]-testpos[1])**2)
                            if dist_pos_j_test_pos>=0.9*(self.agents[i].d+self.agents[j].d)/2: #Neuer Punkt in anderem Menschen?
                                a=False
                            else:   # Wenn Ja, leichte Veränderung der Position
                                # if dist_pos_j_test_pos<dist_pos_j_pos:
                                    a=True
                                    ## Ein 'hack', um Pattsituatione aufzuloesen, nur ein Experiment
                                    self.agents[i].F = self.agents[i].F*0.9 + self.perturbation*np.random.randn(2)
                                    break
                        elif len(self.agents)==1: a = False
                    if a == False:  # Punkt in Wand?
                        h1 = np.array([self.agents[i].d/2,self.agents[i].d/2])
                        for boundery in self.space.bounderies:
                            if np.all(np.logical_and(boundery.pos1-h1 <= testpos, testpos <= boundery.pos2+h1)):
                                a = True
                                self.agents[i].F = self.agents[i].F*0.9 + self.perturbation*np.random.randn(2)
                                break
                            else: a = False
                self.agents[i].pos += self.agents[i].F  #neue Position wird gespeichert
                #print (self.agents[i].pos, self.agents[i].F,'\n -----------------')
            self.exitAgents(app)    #Menschen außerhalb des Raums werden entfernt
            app.painter.moving(self.counter,self.t)
            if len(self.agents)==0: break

    def n(self,i,j):    # Positionverhältnis zweier Menschen wird ermittelt
        #i=agent j=Beteiligter
        return (self.agents[i].pos-self.agents[j].pos)/np.linalg.norm(self.agents[i].pos-self.agents[j].pos)

    def socialForce(self,i,j):  #Bedürfnis andere Menschen nicht umzurennen
        # Berechnung durch eine Funktion des Social-Force-Modells nach Helbing
        n = self.n(i,j)
        A = self.agents[i].A
        aDir = self.agents[i].vAct/np.linalg.norm(self.agents[i].vAct) #Laufrichtung des Agents
        effect = np.exp(self.agents[i].d-np.linalg.norm(self.agents[i].pos-self.agents[j].pos)/self.agents[i].B) # Stärke der Wirkung
        effectDir = (self.agents[i].lamb+(1-self.agents[i].lamb)*((1+(-n*aDir))/2)) #Irrelvant da lamb=0
        #vAct muss ein numpy array sein
        t = A * effect * n * effectDir  #Endberechung
        return t

    def accelerationForce(self,agent):  #Beschleunigungskraft des Menschen
        # Berechnung durch eine Funktion des Social-Force-Modells nach Helbing
        T = 2.7
        direction = self.getdirection(agent.pos)    # Zugriff aufs Vektorfeld mit Übergabe der eigenen Position
        fAcc = (1/T)*(agent.vDes*direction-agent.vAct)
        agent.vAct = fAcc
        return fAcc

    def LotFussPunkt(self,agent,wall):  #Nächsten Punkt der Wand bestimmen
        r = np.array([(wall[0][0]-wall[1][0]),(wall[0][1]-wall[1][1])])/np.linalg.norm(np.array([(wall[0][0]-wall[1][0]),(wall[0][1]-wall[1][1])]))
        s = np.inner(r,agent.pos) - np.inner(r,wall[0])/(np.inner(r,r))
        return (wall[0] + s*r)

    def getPosToBoundery(self,agent,boundery):  #Wo ist der nächste Punkt der Wand
        if agent.pos[0]<boundery.pos1[0]:
            if agent.pos[1]>boundery.pos2[1]:
                return np.array([boundery.pos1[0],boundery.pos2[1]])
            elif agent.pos[1]<boundery.pos1[1]:
                return boundery.pos1
            else:
                return self.LotFussPunkt(agent,(boundery.pos1,np.array([boundery.pos1[0],boundery.pos2[1]])))
        elif agent.pos[0]>boundery.pos2[0]:
            if agent.pos[1]>boundery.pos2[1]:
                return boundery.pos2
            elif agent.pos[1]<boundery.pos1[1]:
                return np.array([boundery.pos2[0],boundery.pos1[1]])
            else: return self.LotFussPunkt(agent,(np.array([boundery.pos2[0],boundery.pos1[1]]),boundery.pos2))
        elif agent.pos[1]>boundery.pos2[1]:
            return self.LotFussPunkt(agent,(np.array([boundery.pos1[0],boundery.pos2[1]]),boundery.pos2))
        else:
            return self.LotFussPunkt(agent,(boundery.pos1,np.array([boundery.pos2[0],boundery.pos1[1]])))

    def bounderyForce(self,agent,boundery): #Abstoßung von Wänden
        # Berechnung durch eine Funktion des Social-Force-Modells nach Helbing
        p = self.getPosToBoundery(agent,boundery)   #gibt nächsten Punkt der Wand zurück
        n = (agent.pos-p)/np.linalg.norm(agent.pos-p)   # in Welche Richtung liegt die Wand
        aDir = agent.vAct/np.linalg.norm(agent.vAct) #Laufrichtung des Agents
        effect = np.exp(agent.d-np.linalg.norm(agent.pos-p)/0.3)
        effectDir = (agent.lamb+(1-agent.lamb)*((1+(-n*aDir))/2))
        t = 0.3 * effect *n * effectDir
        return t

    def exitAgents(self,app):   #Entfernung von Menschen die Außerhalb sind
        for agent in self.agents:
            for aims in self.space.aims:
                if np.all(np.logical_and(aims.pos1 <= agent.pos, agent.pos <= aims.pos2)):
                    self.counter += 1   #Zähler für gerettete Menschen
                    counteragents = []
                    counteragents.append(agent)
                    app.painter.canvas.children.remove(agent.Vis)   #Entfernung der Visuellen Abbildung
                    app.painter.canvas.ask_update()
                    self.agents.remove(agent)   #Entfernung des Menschen aus der Berechnung

if __name__ == "__main__":  #Unwichtig für eigentliches Programm
    aa = []
    aa.append(Agent(1,1,1.5))
    aa.append(Agent(10,10,1.5))
    sp = Space(1)
    m = Mover(aa,sp)
    print np.dot([1,2],[3,4])
    print m.bounderyForce(aa[0],sp.bounderies[4])
