# -*- coding: utf-8 -*-
from __future__ import division
import random 
import math
from Boundery import Boundery
from Model import Model
import numpy as np
import pickle

class Space(object):    #Der Raum in dem die Simulation abläuft
    def __init__(self,modell):  #Deklarierung Variablen, Initialisierung durch Methoden
        self.modelListe = [0,1,2]
        self.wallWidth = 0.15
        self.door = 1
        self.aims = []
        self.bounderies = []
        if modell == "new": # Erzeugung eines neuen Modells(siehe Model.py)
            modell = len(self.modelListe)
            m = Model()
            m.main(modell)
            
        self.width,self.height = self.getWidthHeight(modell)    # Breite und Höhe des Modells wird ermittelt

        self.getBounderies(modell)  # Wände werden erzeugt(Modell eins und zwei)

    def getBounderies(self,modell): # Nur wichtig für Modell eins und zwei
        w = self.width
        h = self.height
        d = self.door
        ww = self.wallWidth
        temp = np.array([0.1,0.1])
        #Innenwände
        #Per Hand werden alle Wände einzeln erzeugt
        if modell == 1:
            self.getAussenwaende()
            self.bounderies.append(Boundery([w/2-d-ww,h/2+d],[w/2-d,h]))
            self.bounderies.append(Boundery([w/2+d,h/2+d],[w/2+d+ww,h]))
            self.bounderies.append(Boundery([w/2-d-ww,0],[w/2-d,h/2-d]))
            self.bounderies.append(Boundery([w/2+d,0],[w/2+d+ww,h/2-d]))
            self.bounderies.append(Boundery([d,h/2+d],[w/2-d,h/2+d+ww]))
            self.bounderies.append(Boundery([d,h/2-d-ww],[w/2-d,h/2-d]))
            self.bounderies.append(Boundery([w/2+d,h/2+d],[w-d,h/2+d+ww]))
            self.bounderies.append(Boundery([w/2+d,h/2-d-ww],[w-d,h/2-d]))
            self.aims.append(Boundery([w/2,-1]-temp,[w/2,-1]+temp))
        if modell == 2:
            self.getAussenwaende()
            self.bounderies.append(Boundery([0,h/3-ww/2],[w/4-d/2,h/3+ww/2]))
            self.bounderies.append(Boundery([w/4+d/2,h/3-ww/2],[w/2-d/2,h/3+ww/2]))
            self.bounderies.append(Boundery([w/2-d/2-ww,0],[w/2-d/2,h*2/3-d/2]))
            self.bounderies.append(Boundery([w/2-d/2-ww,h*2/3+d/2],[w/2-d/2,h]))
            self.bounderies.append(Boundery([w*2/3,0],[w*2/3+ww,h*1/8-d/2]))
            self.bounderies.append(Boundery([w*2/3,h*1/8+d/2],[w*2/3+ww,h*1/2-d/2]))
            self.bounderies.append(Boundery([w*2/3,h*1/4-ww/2],[w*5/6-d/2,h*1/4+ww/2]))
            self.bounderies.append(Boundery([w*5/6+d/2,h*1/4-ww/2],[w,h*1/4+ww/2]))
            self.bounderies.append(Boundery([w*2/3,h*1/2+d/2],[w*2/3+ww,h*3/4]))
            self.bounderies.append(Boundery([w*2/3,h*3/4],[w*5/6-d/2,h*3/4+ww]))
            self.bounderies.append(Boundery([w*5/6+d/2,h*3/4],[w,h*3/4+ww]))
            self.aims.append(Boundery([w/2,-1]-temp,[w/2,-1]+temp))

    def getWidthHeight(self,modell):    # Breite und Höhe des Modells wird ermittelt
        if modell <= 2: #Modelle die Ihre Größe durch User-Eingaben bekommen
            return int(raw_input("Width:  ")),int(raw_input("Height:  "))
        else:   #Lädt Modell und ermittelt Höhe und Breite
            fil = open(str("Model"+str(modell)))
            self.bounderies,self.aims = pickle.load(fil)    #ist der Teil getBounderies
            width = 0
            height = 0
            for boun in self.bounderies:
                if width<boun.pos1[0]: width = boun.pos1[0]
                if height<boun.pos1[1]: height = boun.pos1[1]
                if width<boun.pos2[0]: width = boun.pos2[0]
                if height<boun.pos2[1]: height = boun.pos2[1]
            return width,height

    def getAussenwaende(self):  #Modell eins und zwei haben gleiche Außenwände, daher wird es hier nur einmal gespeichert
        offset = [0,0]
        door_R = [offset[0]+self.width/2+self.door/2,offset[1]]
        corner_BR = [offset[0]+self.width,offset[1]]
        corner_TR = [corner_BR[0],offset[1]+self.height]
        corner_TL = [offset[0],corner_TR[1]]
        corner_BL = offset
        door_L = [door_R[0]-self.door,offset[1]]
        self.bounderies.append(Boundery(door_R,[corner_BR[0],corner_BR[1]+self.wallWidth]))
        self.bounderies.append(Boundery([corner_BR[0]-self.wallWidth,corner_BR[1]],corner_TR))
        self.bounderies.append(Boundery([corner_TL[0],corner_TL[1]-self.wallWidth],corner_TR))
        self.bounderies.append(Boundery(corner_BL,[corner_TL[0]+self.wallWidth,corner_TL[1]]))
        self.bounderies.append(Boundery(corner_BL,[door_L[0],door_L[1]+self.wallWidth]))

